#!/bin/sh

TARGET=$@
LASTDIGESTFILE=".ismodified"
EACHLINK=./eachlink

# get current contents digest
DIGEST=`wget -q -O- $TARGET | $EACHLINK $TARGET \
  | grep -v ^a |grep -v form |grep -v book \
  | sort |uniq \
  | sed 's/^.* //' \
  | wget -q -i- -O- | openssl sha1`

# load last contents digest
LASTDIGEST=''
if test -f $LASTDIGESTFILE; then
    LASTDIGEST=`cat $LASTDIGESTFILE`
fi
# save current contents digest
echo "$DIGEST" > "$LASTDIGESTFILE"


if test "$LASTDIGEST" = "$DIGEST"; then
    exit 0
else
    echo "$TARGET is modified"
    exit 1
fi
