#!/usr/bin/perl

use CGI::Carp qw(fatalsToBrowser);
use CGI;
use Fcntl qw(:flock);
use strict;
use constant PATH_DATABASE => '/tmp/shorturl.txt';


my $r = new CGI;
if ($r->param('add')) {
    do_shorten($r);
}
elsif ($r->path_info) {
    do_redirect($r);
}
else {
    show_input_form($r);
}
exit 0;


sub do_shorten {
    my $r = shift;
    my $next = 'a';

    open DB, '+<'. PATH_DATABASE or die "cannot open database: $!\n";
    flock DB, LOCK_EX;
    my $id;
    while (chomp(my $line = <DB>)) {
        next unless $line =~ m/^(\S+)\s+(.+)$/;
        $id = $1 and last if $2 eq $r->param('add');
        $next++;
    }
    unless ($id) { # is new entry
        printf DB "%s %s\n", $next, $r->param('add');
        $id = $next;
    }
    close DB;
    show_result_form($r, $id);
}

sub do_redirect {
    my $r = shift;
    my $id = $r->path_info;
    $id =~ s{^/}{};

    open DB, '<'. PATH_DATABASE or die "cannot open database: $!\n";
    flock DB, LOCK_SH;
    my $url;
    while (chomp(my $line = <DB>)) {
        next unless $line =~ m/^$id\s+(.+)$/o;
        $url = $1; 
        last;
    }
    close DB;
    unless ($url) { # not found
        return show_input_form($r);
    }
    print $r->redirect($url);
}


sub show_result_form {
    my $r = shift;
    my $id = shift;
    my $html = <<'__HTML__';
<html>
  <body>
    <h1>Shorten URL</h1>
    Before:<br />
    %s<br />
    After:<br />
    %s<br />
  </body>
</html>
__HTML__
    my $base_url = $r->url;

    print $r->header(-type => 'text/html');
    printf $html, $r->param('add'), $base_url. '/'. $id;
}

sub show_input_form {
    my $r = shift;
    my $html = <<'__HTML__';
<html>
  <body>
    <h1>Shorten URL</h1>
    <form method="get">
      URL:<br />
      <input type="text" name="add" /><input type="submit" />
    </form>
  </body>
</html>
__HTML__
    print $r->header(-type => 'text/html');
    print $html;
}
__END__
